// vim: set undofile:
// Program: multi_penguin

#include <string>
#include <iostream>

// Zelimo da napravimo klasu ptica koja moze da pliva i da leti.
// Pticu ne zelimo da korisnik moze direktno da instancira.
class bird {
protected:
    bird(const std::string & species)
        : m_species(species)
    {
    }

public:
    std::string species() const
    {
        return m_species;
    }

private:
    std::string m_species;

};

class can_fly {
public:
    void fly(const std::string & who)
    {
        std::cout << who << " is in the air" << std::endl;
    }

};

// Pravimo klasu soko. Soko bi trebalo da moze da leti
class hawk: public bird, public can_fly {
public:
    hawk()
        : bird("hawk")
    {
    }
};

// Pravimo klasu orao. Orao bi trebalo da moze da leti
class eagle: public bird, public can_fly {
public:
    eagle()
        : bird("eagle")
    {
    }
};

// Sta jos moze da leti, a da nije ptica?
class love: public can_fly {
public:

};

// Pravimo klasu pingvin
class penguin: public bird {
public:
    penguin()
        : bird("penguin")
    {
    }
};

int main(int argc, const char *argv[])
{
    hawk h;
    eagle e;
    penguin p;

    h.fly(h.species());
    e.fly(e.species());
    // p.fly(); // Kompajler nam sada javlja da pingvini ne mogu da lete

    love l;
    l.fly("love");

    return 0;
}
